Loading...
Searching...
No Matches
pqxx::pipeline Class Reference

Processes several queries in FIFO manner, optimized for high throughput. More...

Inheritance diagram for pqxx::pipeline:
[legend]
Collaboration diagram for pqxx::pipeline:
[legend]

## Public Types

using | query_id = long
| Identifying numbers for queries.

## Public Member Functions

| pipeline (pipeline const &)=delete
pipeline & | operator= (pipeline const &)=delete
| pipeline (pipeline &&)=delete
pipeline & | operator= (pipeline &&)=delete
| pipeline (transaction_base &t)
| Start a pipeline.
| pipeline (transaction_base &t, std::string_view tname)
| Start a pipeline. Assign it a name, for more helpful error messages.
| ~pipeline () noexcept
| Close the pipeline.
query_id | insert (std::string_view) &
| Add query to the pipeline.
void | complete ()
| Wait for all ongoing or pending operations to complete, and detach.
void | flush ()
| Forget all ongoing or pending operations and retrieved results.
void | cancel ()
| Cancel ongoing query, if any.
bool | is_finished (query_id) const
| Is result for given query available?
result | retrieve (query_id qid)
| Retrieve result for given query.
std::pair< query_id, result > | retrieve ()
| Retrieve oldest unretrieved result (possibly wait for one).
bool | empty () const noexcept
int | retain (int retain_max=2) &
void | resume () &
| Resume retained query emission. Harmless when not needed.
Public Member Functions inherited from pqxx::transaction_focus
| transaction_focus (transaction_base &t, std::string_view cname, std::string_view oname)
| transaction_focus (transaction_base &t, std::string_view cname, std::string &&oname)
| transaction_focus (transaction_base &t, std::string_view cname)
| transaction_focus (transaction_focus const &)=delete
transaction_focus & | operator= (transaction_focus const &)=delete
constexpr std::string_view | classname () const noexcept
| Class name, for human consumption.
std::string_view | name () const &noexcept
| Name for this object, if the caller passed one; empty string otherwise.
std::string | description () const
| transaction_focus (transaction_focus &&other)
transaction_focus & | operator= (transaction_focus &&other)

## Additional Inherited Members

Protected Member Functions inherited from pqxx::transaction_focus
void | register_me ()
void | unregister_me () noexcept
void | reg_pending_error (std::string const &) noexcept
bool | registered () const noexcept
Protected Attributes inherited from pqxx::transaction_focus
transaction_base * | m_trans

## Detailed Description

Processes several queries in FIFO manner, optimized for high throughput.

Use a pipeline if you want to keep doing useful work while your queries are executing. Result retrieval is decoupled from execution request; queries "go in at the front" and results "come out the back."

Actually, you can retrieve the results in any order if you want, but it may lead to surprising "time travel" effects if any of the queries fails. In particular, syntax errors in the queries can confuse things and show up too early in the stream of results.

Generally, if any of the queries fails, it will throw an exception at the point where you request its result. But it may happen earlier, especially if you request results out of chronological order.

Warning
  While a pipeline is active, you cannot execute queries, open streams, etc. on the same transaction. A transaction can have at most one object of a type derived from pqxx::transaction_focus active on it at a time.

## Member Function Documentation

## cancel()

void pqxx::pipeline::cancel | ( |  | ) |

Cancel ongoing query, if any.

May cancel any or all of the queries that have been inserted at this point whose results have not yet been retrieved. If the pipeline lives in a backend transaction, that transaction may be left in a nonfunctional state in which it can only be aborted.

Therefore, either use this function in a nontransaction, or abort the transaction after calling it.

## complete()

void pqxx::pipeline::complete | ( |  | ) |

Wait for all ongoing or pending operations to complete, and detach.

Detaches from the transaction when done.

This does not produce the queries' results, so it may not report any errors which may have occurred in their execution. To be sure that your statements succeeded, call retrieve until the pipeline is empty.

## flush()

void pqxx::pipeline::flush | ( |  | ) |

Forget all ongoing or pending operations and retrieved results.

Queries already sent to the backend may still be completed, depending on implementation and timing.

Any error state (unless caused by an internal error) will also be cleared. This is mostly useful in a nontransaction, since a backend transaction is aborted automatically when an error occurs.

Detaches from the transaction when done.

## insert()

pqxx::pipeline::query_id pqxx::pipeline::insert | ( | std::string_view | q | ) | &

Add query to the pipeline.

Queries accumulate in the pipeline, which sends them to the backend in a batch separated by semicolons. The queries you insert must not use this trick themselves, or the pipeline will get hopelessly confused!

Returns
  Identifier for this query, unique only within this pipeline.

## retain()

int pqxx::pipeline::retain | ( | int | retain_max = `2` | ) | &

Set maximum number of queries to retain before issuing them to the backend. The pipeline will perform better if multiple queries are issued at once, but retaining queries until the results are needed (as opposed to issuing them to the backend immediately) may negate any performance benefits the pipeline can offer.

Recommended practice is to set this value no higher than the number of queries you intend to insert at a time.

Parameters

  retain_max | A nonnegative "retention capacity;" passing zero will cause queries to be issued immediately

Returns
  Old retention capacity

## retrieve() [1/2]

std::pair< pqxx::pipeline::query_id, pqxx::result > pqxx::pipeline::retrieve | ( |  | ) |

Retrieve oldest unretrieved result (possibly wait for one).

Returns
  The query's identifier and its result set.

## retrieve() [2/2]

result pqxx::pipeline::retrieve | ( | query_id | qid | ) |

inline

Retrieve result for given query.

If the query failed for whatever reason, this will throw an exception. The function will block if the query has not finished yet.

Warning
  If results are retrieved out-of-order, i.e. in a different order than the one in which their queries were inserted, errors may "propagate" to subsequent queries.

The documentation for this class was generated from the following files:

- /build/libpqxx-dRO3di/libpqxx-7.10.0/include/pqxx/pipeline.hxx
- /build/libpqxx-dRO3di/libpqxx-7.10.0/src/pipeline.cxx